stages:
  - build
  - test
  - deploy
  - revert

variables:
  docker_html_path: "/var/www"
  env: prod
  deploy_subfolder: html
  REACT_APP_WEBSITE_PREFIX: ""
    # REACT_APP_WEBSITE_PREFIX: "[branch=$CI_COMMIT_BRANCH]"
    #run_test:
    #  stage: deploy
    #  script:
    #    - cp -r build_$env /www/test-app/$CI_COMMIT_SHA
    #    - cp -Pv /www/html /www/test-app/$CI_COMMIT_SHA/prev-version
    #    - ln -fsnv /var/www/test-app/$CI_COMMIT_SHA /www/html

install_dependencies:
  image: node:14.15.0-stretch
  stage: build
  script:
    - yarn install
    - yarn build
    - mv build build_$env
  artifacts:
    paths:
      - node_modules
      - build_$env
  cache:
    key:
      files:
        - yarn.lock
    paths:
      - node_modules

build_staging:
  extends: install_dependencies
  variables:
    env: staging
    REACT_APP_WEBSITE_PREFIX: "[branch=$CI_COMMIT_BRANCH]"
    #REACT_APP_WEBSITE_PREFIX: "[stages1]"
    PUBLIC_URL: "/$CI_COMMIT_BRANCH"

deploy_staging:
  extends: deploy_prod
  variables:
    deploy_subfolder: staging/$CI_COMMIT_BRANCH
    env: staging
  when: always
  only:
    - master
    - /feature-.*/

deploy_prod:
  stage: deploy
  script:
    - cp -r build_$env $docker_html_path/test-app/${env}_$CI_COMMIT_SHA
      #- cp -Pv $docker_html_path/$deploy_subfolder $docker_html_path/test-app/${env}_$CI_COMMIT_SHA/prev-version || true
    - ln -fsnv $docker_html_path/test-app/${env}_$CI_COMMIT_BEFORE_SHA $docker_html_path/test-app/${env}_$CI_COMMIT_SHA/prev-version || true
  only:
    - master

activate_staging:
  extends: activate_prod
  variables:
    deploy_subfolder: staging/$CI_COMMIT_BRANCH
    env: staging
  when: always
  only:
    - master
    - /feature-.*/

activate_prod:
  stage: deploy
  script:
    - ln -fsnv /var/www/test-app/${env}_$CI_COMMIT_SHA $docker_html_path/$deploy_subfolder
  when: manual
  only:
    - master

revert:
  stage: revert
  when: manual
  script:
    - rm $docker_html_path/$deploy_subfolder
    - cp -Pv --remove-destination $docker_html_path/test-app/$CI_COMMIT_SHA/prev-version $docker_html_path/html

revert_previous:
  stage: revert
  when: manual
  script:
    - rm $docker_html_path/$deploy_subfolder
    - cp -Pv $docker_html_path/test-app/${env}_$CI_COMMIT_BEFORE_SHA/prev-version $docker_html_path/$deploy_subfolder

revert_previous:
  stage: revert
  when: manual
  script:
    - rm $docker_html_path/$deploy_subfolder
    - cp -Pv $docker_html_path/test-app/${env}_$CI_COMMIT_BEFORE_SHA/prev-version $docker_html_path/$deploy_subfolder

